# pongws
## How to Play
Transfer both the PONGWS and XPONGWS.8xp to your TI-84+CSE.
This program will only play on the TI-84+CSE.

To play, run the "XPONGWS.8xp" program as you would a 
regular program. XPONGWS is the launcher.

You will be presented with a series of menus. 
"Single player?" determines whether or not you wish to
disable or enable CPU or multiplayer gameplay.

In single-player mode, you control the left paddle using
the up and down arrow keys. 

In multiplayer mode, you control the left paddle using 
the 1 and 0 keys and right paddle using the 3 and (-) 
keys.

The next option asks if you wish to disable the audio.
If you choose "no", then audio will be played out of the
2.5mm I/O port at the top of calculator.

You need a pair of headphones or speakers with either a
2.5mm male TRS connector on the end of the speaker or
headphone cable itself, or you need a 3.5mm female to
2.5mm male TRS connector. This will allow any standard
pair of headphones to work with the calculator.

Note: Sometimes plugging in a pair of headphones will
cause the calculator to freeze. This only occurs if you
plug in a pair of headphones on the home menu or while
using the launcher. It will not occur while the program
is actually running.

Unfreezing the calculator just requires unplugging the
headphones. If this issue occurs, then simply wait until
the game actually starts--after you select your options
in the launcher--and then plug in your headphones.

You will then be presented with the difficulty. "Casual"
is easier than "Normal". "Hard" is the most difficult.
It mainly just adjusts how fast the CPU paddle moves 
towards the ball.

Finally, you will be presented with themes. This is just
a control for the foreground and background color of the
game. 

Afterwards, the game will start.

A good strategy to beating the CPU is to hit the ball at
an angle. The angle of the ball depends on the angle it 
collides with your paddle. Have it hit the top or bottom
of the paddle to send it off at an angle. 

## About
PONGWS, or "Pong with Sound", is a Pong clone with audio.

It it built for the TI-84+CSE and the TI-84+CSE only.

The audio is played through the 2.5mm jack on the top-left
of the calculator.

The audio is built off of the "NoteMan" audio library, 
which I had written in 2013/2014. It is included in the
"src/NoteMan" folder. It is cross-compatible with older
TI-84+ models (and probably the TI-83+ as well).

The graphics library I had written in 2016 specifically
for the TI-84+CSE. It can be used to draw sprites to the
screen, filled rectangles, clear the screen, 
adjust windows, etc.

The source code also contains the source code for 
"ppm84cse". This is a program I wrote in C to convert
PPM images to images that can be easily displayed by the
TI-84+CSE. The sprite drawing subroutine of the graphics
library expects images in this format.

All of these are free to use as you wish. 

##Compilation
Note: compilation is not required. The program should 
contain precompiled binaries in the "bin" directory.

The source code contains a makefile but it is essentially
just a Bash script. It may run on Windows with Cygwin, but
it is specifically written for Linux.

Compilation requires GCC and SPASM on your system. GCC is
a C compiler while SPASM is a Z80 Assembler. If you are 
using Linux, simply run "make" and it should compile. 

If you cannot get it to compile, here are the steps to
compiling it.

Compilation requires first to compile ppm84cse. This is done
using GCC.

gcc -lm ppm84cse.c -o ppm84cse

This program is then used to generate "sprites.asm" within the
"images" directory. Navigate to the "images" directory and 
generate the "sprites.asm" file.

ppm84cse 0.ppm IMG0 > sprites.asm
ppm84cse 1.ppm IMG1 >> sprites.asm
ppm84cse 2.ppm IMG2 >> sprites.asm
ppm84cse 3.ppm IMG3 >> sprites.asm
ppm84cse 4.ppm IMG4 >> sprites.asm
ppm84cse 5.ppm IMG5 >> sprites.asm
ppm84cse 6.ppm IMG6 >> sprites.asm
ppm84cse 7.ppm IMG7 >> sprites.asm
ppm84cse 8.ppm IMG8 >> sprites.asm
ppm84cse 9.ppm IMG9 >> sprites.asm

Finally, navigate back to the src file and compile PONGWS.asm 
with SPASM.

spasm -A PONGWS.asm PONGWS.8xp

Inside "LAUNCHER" is the TI-BASIC program to launch the file.
There are no steps to compile it as I consider TI-BASIC
programs to, in thesmelves, the source code.

Included anyways is a ".tib" file that simply contains the code
in a text format.
